#!/usr/bin/env perl

# LSG::Misc - miscellaneous functions for the LSG
# Written by lumidify <nobody@lumidify.org>
# Last updated: 2019-08-21
#
# To the extent possible under law, the author has dedicated
# all copyright and related and neighboring rights to this
# software to the public domain worldwide. This software is
# distributed without any warranty.
#
# You should have received a copy of the CC0 Public Domain
# Dedication along with this software. If not, see
# <http://creativecommons.org/publicdomain/zero/1.0/>.

package LSG::Misc;
use strict;
use warnings;
use utf8;
use open qw< :encoding(UTF-8) >;

# Generate relative link - both paths must already be relative,
# starting at the same place!
# e.g. "bob/hi/whatever/meh.txt","bob/hi/bla/fred.txt" => ../bla/fred.txt
sub gen_relative_link {
        my ($base, $linked) = @_;
        my @parts_base = split("/", $base);
        my @parts_linked = split("/", $linked);
        # don't include last element in @parts_base (the filename)
        my $i = 0;
        while ($i < $#parts_base && $i < $#parts_linked) {
                if ($parts_base[$i] ne $parts_linked[$i]) {
                        last;
                }
                $i++;
        }
        my $rel_lnk = "";
        $rel_lnk .= "../" x ($#parts_base-$i);
        $rel_lnk .= join("/", @parts_linked[$i..$#parts_linked]);
        return $rel_lnk;
}

1;
